'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

require('isomorphic-fetch');

var _initDomTree = require('./initDomTree');

var _initDomTree2 = _interopRequireDefault(_initDomTree);

var _puzzle = require('./puzzle');

var _puzzle2 = _interopRequireDefault(_puzzle);

var _slider = require('./slider');

var _slider2 = _interopRequireDefault(_slider);

var _cache = require('./cache');

var _cache2 = _interopRequireDefault(_cache);

var _eventName = require('./eventName');

var _eventName2 = _interopRequireDefault(_eventName);

var _emitter = require('./emitter');

var _emitter2 = _interopRequireDefault(_emitter);

var _dom = require('./dom');

var _handler = require('./slider/handler');

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _merge = require('lodash/merge');

var _merge2 = _interopRequireDefault(_merge);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import Promise from 'es6-promise'


var sliderPuzzle = function sliderPuzzle(root) {
  require('./event/reset');
  require('./event/enable');
  require('./event/disable');
  require('./event/validate');
  require('./event/notify');
  require('./event/refresh');
  require('./event/error');

  (0, _initDomTree2.default)(root);
  (0, _puzzle2.default)();
  (0, _slider2.default)();
};
// Promise.polyfill()


sliderPuzzle.destroy = function () {
  if (!_cache2.default.root) {
    return;
  }
  (0, _dom.remove)(_cache2.default.slider, _eventName2.default.start, _handler.onStart);
  (0, _dom.remove)(_cache2.default.refresh, _eventName2.default.start, _handler.onRefresh);
  (0, _dom.remove)(_cache2.default.root, _eventName2.default.onHover, _handler.onHover);
  (0, _dom.remove)(_cache2.default.root, _eventName2.default.offHover, _handler.offHover);
};
sliderPuzzle.emitter = _emitter2.default;

// overwrite some config
sliderPuzzle.setConfig = function (overConfig) {
  (0, _merge2.default)(_config2.default, overConfig);
};

exports.default = sliderPuzzle;