'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _config = require('./config1');

var _config2 = _interopRequireDefault(_config);

var _config3 = require('./config2');

var _config4 = _interopRequireDefault(_config3);

var _config5 = require('./config3');

var _config6 = _interopRequireDefault(_config5);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var config = {
  bgWidth: 294,
  bgHeight: 111,

  // puzzle为正方形，用一个边长表示宽和高
  puzzleSide: 40,

  // 凸凹槽的半径
  slotRadius: 6,

  // 允许的误差
  allowedDistance: 3,

  port: 3010,

  // 存储每次生成的验证信息的方式
  store: 'redis',
  // more config, go https://www.npmjs.com/package/redis
  redisConfig: {
    host: '127.0.0.1',
    port: '6379'
  },

  // 一分钟过期
  expire: 1000 * 60,

  // 客户端最大重试次数
  // 超过后提示需要刷新页面重试
  maxRetry: 10,

  // api
  api: {
    captcha: '/captcha',
    validate: '/validate'
  },

  // 允许访问的ip，不填则为不验证
  // allowedIps: ['127.0.0.1'],

  // 背景图存放路径，以/结尾
  // 若配置该参数则使用该路径内的图，否则使用随机生成背景
  bgPath: __dirname + '/img/bg/',

  // 滑块提示文字
  hint: '拖动滑块完成拼图'
};

if (process.env.DIST_ENV === '1') {
  config = _config2.default;
} else if (process.env.DIST_ENV === '2') {
  config = _config4.default;
} else if (process.env.DIST_ENV === '3') {
  config = _config6.default;
}

exports.default = config;