import 'isomorphic-fetch'
// import Promise from 'es6-promise'
import initDomTree from './initDomTree'
import puzzle from './puzzle'
import slider from './slider'
import cache from './cache'
import eventName from './eventName'
import emitter from './emitter'
import {remove} from './dom'
// Promise.polyfill()
import {onHover, offHover, onStart, onRefresh} from './slider/handler'
import config from '../config'
import merge from 'lodash/merge'


const sliderPuzzle = root => {
  require('./event/reset')
  require('./event/enable')
  require('./event/disable')
  require('./event/validate')
  require('./event/notify')
  require('./event/refresh')
  require('./event/error')

  initDomTree(root)
  puzzle()
  slider()
}

sliderPuzzle.destroy = () => {
  if (!cache.root) {
    return
  }
  remove(cache.slider, eventName.start, onStart)
  remove(cache.refresh, eventName.start, onRefresh)
  remove(cache.root, eventName.onHover, onHover)
  remove(cache.root, eventName.offHover, offHover)
}
sliderPuzzle.emitter = emitter

// overwrite some config
sliderPuzzle.setConfig = overConfig => {
  merge(config, overConfig)
}

export default sliderPuzzle
