import config1 from './config1'
import config2 from './config2'
import config3 from './config3'
let config = {
  bgWidth: 294,
  bgHeight: 111,

  // puzzle为正方形，用一个边长表示宽和高
  puzzleSide: 40,

  // 凸凹槽的半径
  slotRadius: 6,

  // 允许的误差
  allowedDistance: 3,

  port: 3010,

  // 存储每次生成的验证信息的方式
  store: 'redis',
  // more config, go https://www.npmjs.com/package/redis
  redisConfig: {
    host: '127.0.0.1',
    port: '6379',
  },

  // 一分钟过期
  expire: 1000 * 60,

  // 客户端最大重试次数
  // 超过后提示需要刷新页面重试
  maxRetry: 10,

  // api
  api: {
    captcha: '/captcha',
    validate: '/validate',
  },

  // 允许访问的ip，不填则为不验证
  // allowedIps: ['127.0.0.1'],

  // 背景图存放路径，以/结尾
  // 若配置该参数则使用该路径内的图，否则使用随机生成背景
  bgPath: __dirname + '/img/bg/',

  // 滑块提示文字
  hint: '拖动滑块完成拼图'
}

if (process.env.DIST_ENV === '1') {
  config = config1
} else if (process.env.DIST_ENV === '2') {
  config = config2
} else if (process.env.DIST_ENV === '3') {
  config = config3
}

export default config
